/*
 * Trampoline Dismount v0.01a by Shrodes
 *
 * Version History
 *
 * v0.01a- Started making this mod. Fixed level up. Changed text. Still experimenting. Made score when you touch mat. Adding  *         somersault and time systems in. Done! Scoring now works and time does too! Adding in score table. Added score      *         table. Starting to be fun! Still have to fix up some bugs. Added some new level blocks. Looks better by a mile.    *         v0.01a finished.
 * 
 */

const int MAX_TIME = 10000;

uint mTime;
uint gravTime = 0;
uint multiTimer = 0;
uint latkaTimer = 0;
uint latkaTimer2 = 0;
uint bTimer = 0;
uint redTimer = 0;
uint frame = 0;

int screenWidth, screenHeight;

int timeLeft;
int score = 0;
int somersaults = 0;
int finalsomersaults = -1;

float height = 0;
float yourScore;
float finalScore;

GameApp *app;
UIFont *medFont, *smallFont;
uint medFontHeight, smallFontHeight;
PhysicsWorld *pw;

PhysicsObject *head, *neck, *trunk, *rthigh, *lthigh, *rcalf, *lcalf, *rfore, *lfore, *larm, *rarm, *rfoot, *lfoot;

bool finished = false;
bool aborted = false;

bool l1remove = false;
bool l2remove = false;
bool l3remove = false;
bool l4remove = false;
bool l5remove = false;
bool l1 = true;
bool l2 = true;
bool l3 = true;
bool l4 = true;
bool l5 = true;

bool redScore = false;

bool b1 = false;
bool b2 = false;
bool b3 = false;

bool headAbove = true;

PhysicsObject *lastBumper;

PhysicsObject *col1, *col2;

int multiplier = 1;

float gravX, gravY, gravZ;

// Called once on level initialization.
void onInit()
{
	app = getGameApp();
	screenWidth = app->getScreenWidth();
	screenHeight = app->getScreenHeight();
	medFont = app->getFont("medium");
	smallFont = app->getFont("small");
	medFontHeight = medFont->getFontHeight();
	smallFontHeight = smallFont->getFontHeight();

	app->setClearColor(0.5,0.5,0.8);

	pw = app->getPhysicsWorld();

	head = pw->findObject("Head");
	neck = pw->findObject("Neck");
	trunk = pw->findObject("Trunk");
	rthigh = pw->findObject("RightThigh");
	lthigh = pw->findObject("LeftThigh");
	rarm = pw->findObject("RightArm");
	larm = pw->findObject("LeftArm");
	rfore = pw->findObject("RightForearm");
	lfore = pw->findObject("LeftForearm");
	rcalf = pw->findObject("RightCalf");
	lcalf = pw->findObject("LeftCalf");
	rfoot = pw->findObject("RightFoot");
	lfoot = pw->findObject("LeftFoot");

	revertColors();

}

void revertColors() {
	head->setColor(1,0,0);
	neck->setColor(1,0,0);
	trunk->setColor(1,0,0);
	rthigh->setColor(1,0,0);
	lthigh->setColor(1,0,0);
	rarm->setColor(1,0,0);
	larm->setColor(1,0,0);
	rfore->setColor(1,0,0);
	lfore->setColor(1,0,0);
	rcalf->setColor(1,0,0);
	lcalf->setColor(1,0,0);
	rfoot->setColor(1,0,0);
	lfoot->setColor(1,0,0);
}


// Called once for each game logic update before the physics update.
// Parameter 'time' is the simulation time in milliseconds.
void onUpdate(uint time)
{
	++frame;
	mTime = time;
	if (!finished && !aborted)
    {
        timeLeft = int(MAX_TIME) - int(time);
        if (timeLeft < 0)
            timeLeft = 0;
        if (timeLeft == 0 && !aborted)
        {
            if (!aborted) finished = true;
        }
    }
	
	float a, b, c = 0;
	head->getPosition(a, b, c);
	float headA = c;
	
	trunk->getPosition(a,b,c);
	float trunkB = c;
	if (c > height) height = c;

	if (!headAbove && headA > trunkB) {
		headAbove = true;
		somersaults++;
	} else if (headAbove && headA < trunkB) {
		headAbove = false;
	}

	if (l1remove) {
		pw->findObject("latka1")->removeFromPhysicsWorld();
		playSound(3);
		l1remove = false;
		l1 = false;
		score += 1000 * multiplier;
	}

	if (l2remove) {
		pw->findObject("latka2")->removeFromPhysicsWorld();
		playSound(3);
		l2remove = false;
		l2 = false;
		score += 1000 * multiplier;
	}

	if (l3remove) {
		pw->findObject("latka3")->removeFromPhysicsWorld();
		playSound(3);
		l3remove = false;
		l3 = false;
		score += 1000 * multiplier;
	}

	if (l4remove) {
		pw->findObject("latka4")->removeFromPhysicsWorld();
		playSound(3);
		l4remove = false;
		l4 = false;
		score += 1000 * multiplier;
	}

	if (l5remove) {
		pw->findObject("latka5")->removeFromPhysicsWorld();
		playSound(3);
		l5remove = false;
		l5 = false;
		score += 1000 * multiplier;
	}

	if (b1 && b2 && b3 && bTimer == 0) {
		playSound(5);
		bTimer = mTime + 2000;
		score += 50000 * multiplier;
	}

	if ((mTime > bTimer) && b1 && b2 && b3) {
		b1 = false;
		b2 = false;
		b3 = false;
		pw->findObject("black1")->setColor(0,0,0); 
		pw->findObject("black2")->setColor(0,0,0); 
		pw->findObject("black3")->setColor(0,0,0); 
		bTimer = 0;
	}

	if (!l4 && !l5 && latkaTimer2 == 0) {
		playSound(5);
		latkaTimer2 = mTime + 2000;
		score += 10000 * multiplier;
	}

	if ((mTime > latkaTimer2) && (!l4 && !l5)) {
		pw->findObject("latka4")->createToPhysicsWorld();
		pw->findObject("latka5")->createToPhysicsWorld();
		l4 = true;
		l5 = true;
		latkaTimer2 = 0;
	}

	if ((!l1 && !l2 && !l3) && (latkaTimer == 0)) {
		playSound(5);
		latkaTimer = mTime + 2000;
		multiTimer = mTime + 10000;
		multiplier *= 2;
	}

	if ((mTime > latkaTimer) && (!l1 && !l2 && !l3)) {
		pw->findObject("latka1")->createToPhysicsWorld();
		pw->findObject("latka2")->createToPhysicsWorld();
		pw->findObject("latka3")->createToPhysicsWorld();
		l1 = true;
		l2 = true;
		l3 = true;
		latkaTimer = 0;
	}

	if (mTime > multiTimer) multiplier = 1;
	if (mTime > redTimer) redScore = false;

	float x, y, z = 0;
	trunk->getPosition(x,y,z);

	if (z < -5) {
	finished = true;
	setGameState(GAMESTATE_FINISHED);
	}

	if (x > 2 && x < 5) pw->setGravity(0,0,5);
	else pw->setGravity(0,0,-2);

	if (mTime < gravTime) pw->setGravity(gravX, gravY, gravZ);

	revertColors();
}

bool playerHit(bstr name) {
	return ((col1->getType() == PHYSOBJ_RAGDOLL_BODY && col2->getName() == name) || (col2->getType() == PHYSOBJ_RAGDOLL_BODY && col1->getName() == name));
}

// Called when there is a collision between the two given objects.
// Returns true to create contacts or false to ignore collision.
bool onCollision(PhysicsObject *o1, PhysicsObject *o2) {

	col1 = o1;
	col2 = o2;

	bstr o1name = o1->getName();
	bstr o2name = o2->getName();

	if (playerHit("maila"))
	{
		playSound(-1);
		gravTime = mTime + 1000;
		gravX = 0;
		gravY = 0;
		gravZ = 3;
		score += 10;
	}

	if (playerHit("latka1")) l1remove = true;
	if (playerHit("latka2")) l2remove = true;
	if (playerHit("latka3")) l3remove = true;
	if (playerHit("latka4")) l4remove = true;
	if (playerHit("latka5")) l5remove = true;

	if (playerHit("black1")) {b1 = true; pw->findObject("black1")->setColor(1,1,1); return false;}
	if (playerHit("black2")) {b2 = true; pw->findObject("black2")->setColor(1,1,1); return false;}
	if (playerHit("black3")) {b3 = true; pw->findObject("black3")->setColor(1,1,1); return false;}

	if ((redTimer > mTime) && (playerHit("red"))) {
		if (!redScore) {
			redScore = true;
			score += 100000 * multiplier;
		}
		return false;
	}

	if (playerHit("yellow")) {
		redTimer = mTime + 2000;
	}

	if (o1name == "bumper") {
		bumperHit(o1);
	}
	if (o2name == "bumper") {
		bumperHit(o2);
	}

	// generate collision
	return true;
}

void bumperHit(PhysicsObject *obj) {
		
		if (lastBumper != obj) {
			score+=500;
			lastBumper = obj;
		}

		gravTime = mTime + 250;

		uint dir = mTime % 1000;
		gravY = 0;

		gravX = 2;
		gravZ = 0;

		if (dir > 250) gravX = -2;

		if (dir > 500) {
			gravX = -2;
			gravZ = 0;
		}
		if (dir > 750) {
			gravX = -2;
		}

}

// Called when the game view is rendered.
// Might happen more or less frequently than update calls.
void onRender()	{
	if (mTime < 5000) {
		medFont->drawString(float(screenWidth / 2), 70, UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_BOTTOM, "Trampoline Dismount v0.01a");
    	}
	smallFont->drawString(100,20, UIFONT_ALIGN_HORIZ_CENTER, "Flips: " + bstrFormat(somersaults));

	if (multiplier > 1) medFont->drawString(float(screenWidth / 2), float(screenHeight / 2), UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_BOTTOM, "Multiplier x" + bstrFormat(multiplier));
	
	drawTime();

	if (aborted) drawFailure();
	if (finished) drawVictory(); 
	if (finished) setGameState(GAMESTATE_FINISHED); 
}
void drawTime()
{
    const float x = 100, y = 70;
    int fracs = (timeLeft / 10) % 100;
    int seconds = timeLeft / 1000;
    bstr fracsStr = (fracs < 10 ? "0" : "") + bstrFormat(fracs);

    medFont->drawString(x, y, UIFONT_ALIGN_HORIZ_CENTER, ":");
    medFont->drawString(x - 4, y, UIFONT_ALIGN_RIGHT, bstrFormat(seconds));
    medFont->drawString(x + 4, y, UIFONT_ALIGN_DEFAULT, fracsStr);
    smallFont->drawString(x, y + float(medFontHeight),
                          UIFONT_ALIGN_HORIZ_CENTER, "Time Left");
}
void drawFailure()
{
	medFont->drawString(float(screenWidth / 2), float(screenHeight / 2), UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER, "You fell off the trampoline!", 1, 1, 1, 1);
}
void drawVictory()
{
	medFont->drawString(float(screenWidth / 2), float(screenHeight / 4), UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER, "Your run is over!");
	medFont->drawString(float(screenWidth / 2), float(screenHeight / 4) + 60, UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER, "Flips: " + bstrFormat(int(somersaults)));
	medFont->drawString(float(screenWidth / 2), float(screenHeight / 4) + 120, UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER, "Score during the run: " + bstrFormat(int(score)));
	medFont->drawString(float(screenWidth / 2), float(screenHeight / 4) + 180, UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER,
		"Total: " + bstrFormat(int((somersaults * 1000) + (score * 150))));
}

